;schiessbude
;sensenstahl
;www.sensenstahl.com
;fasm 1.69.31
;listening: aspidistrafly - companion to owls
;____________________________________________________________________________

;based on "schiessbude", one of the games on the poly-play arcade. but again
;very simplyfied and changed. without ducks. but with score.

;assuming ax = 0 cx = 255 bx = 0 di = 100h

;global used registers: si : player pos
;                       bp : shot pos
;                       bx : ammo
;                       cx : frame counter

;if enemies reach the indicated spot on the right it is game over. so it is if
;you run out of ammo. every shot takes away 1 bullet from your ammo count. if
;you hit the 01h ascii nothing happens. if you hit ascii 02h (solid smiley)
;you get 1 shot back so it is a -+0 game. if you hit the heart 03h you get 3
;shots back. any time you hit an enemy your score gets increased by 1.

;controls: a/d : move left/rite
;          s   : shoot
;          esc : chicken out

;uses vsync for constant speed of frames

;there is a little flaw in the game or should i say advanced technology to help
;the player? anyway, sometimes when movement of enemies and shot overlap on the
;same position it can happen that 2 enemies get deleted (but only counting 1)

;well, yeah. another idea i had and made for fun to do it. maybe with a 1 time
;try though :D but it might be the game so far with the most global used registers.
;yay.

org 100h
use16

start:   push 0b800h ;textmooooooode
frmz:    pop ds
;        inc ax      ;mov al,01h; 1 = 40*25 16 colors
                     ;works.
         int 10h

;needed because if you die memory would be identical after restart
cls:
mov byte[ds:bx],ch;0
inc bx
jnz cls

;mov cx,0101h ;init frame counter
inc cx ;0100h
inc cx ;0101h

inc word[ds:80*22-2]    ;set borders but let them stay hidden
inc word[ds:80*22+78]

;init 1st digit of score with real arcade color :D
mov word[ds:80*23+78],0d30h ;'0' = 48 = 30h


mov si,80*22+20 ;init player pos

xor bp,bp       ;no shot active
                 ;removing that and setting score to '0'-1
                 ;makes things work while saving

;bx = 0
mov bl,31 ;shots available
          ;40 (whole screen) feels meh and 20 not enough
          ;so 30 shots is a nice way in the middle
          ;internal this is 1 shot more than there
          ;is displayed because how it all works
          ;so giving the last shot does not cause
          ;errors while hoping that one hits a
          ;juicy target

main:

mov dx,3dah     ;wait for vsync for constant speed
vsync1:         ;of the frames
in al,dx        ;setting stuff here
test al,8       ;makes dx reusable
jnz vsync1
vsync2:
in al,dx
test al,8
jz vsync2


xor dx,dx        ;sir reuse-a-lot

;di is minimal 1 here because 0 quits
mov di,bx ;get ammo number
dec di    ;if di = 1 assume on screen that it is the
          ;last shot (which still can hit a target)
          ;so this workaround has to be made
shl di,1  ;since word access

mov word[ds:di+80*24],dx;0 ;delete end of the
                           ;ammo row
ammo:
cmp di,dx;0 ;last shot given?
je outta    ;yes so do not display any ammo
dec di
dec di
mov word[ds:di+80*24],0ab3h
jmp ammo
outta:

;faulty code, if you got 1 shot left in the ammo
;it still quits
;di is minimal 1 here because 0 quits
;mov bx,di
;shl bx,1
;mov word[ds:bx+80*24],dx;0
;ammo:
;mov word[ds:bx+80*24-2],0ab3h
;dec bx
;dec bx
;jnz ammo


;frame handler
dec ch      ;gives speed of the shot
jnz droppz  ;do nothing but display player pos
;mov ch,5    ;reset and move/display shot if active
            ;plus check if shot hits enemy
            ;move this to after skippz makes using dec cx
            ;below possible and -1b

;dec cl      ;gives speed of enemy movement
dec cx       ;ch = 0
jnz skippz  ;do not move/create enemies
mov cl,10    ;reset and move/create enemies

;bl = ?
mov di,80*10+78

moving:
xor ax,ax
xchg ax,word[ds:di-2] ;delete old enemy
cmp al,0b3h          ;do not move shot
je nono
mov word[ds:di],ax   ;set enemy on new pos
nono:
dec di
dec di
jnz moving

in al,40h ;advanced
mul al    ;rnd tech

shr ax,14 ;0..3
;cmp ax,dx;0
;je nothing
mov ah,10
mov word[ds:di],ax ;set new rnd enemy
nothing:

skippz:
mov ch,3    ;reset and move/display shot if active
            ;plus check if shot hits enemy

cmp bp,dx;0
je droppz ;shot not active
mov word[ds:bp],dx;0 ;del old shot
sub bp,80         ;move shot
jnc okok          ;not of of screen yet
reset:
xor bp,bp        ;reset, deactivate shot
jmp droppz       ;don't draw shot when reset
okok:

;did shot hit a target?
cmp byte[ds:bp],dl;0
je no_hit


mov di,80*23+78 ;initial score pos
againor:
inc byte[ds:di]    ;+1
cmp byte[ds:di],'9';reached 9?
jna finefine       ;no
mov byte[ds:di],'0';yes so set 0
dec di             ;and move to the left
dec di
cmp word[ds:di],dx;0 ;no digit there on the left?
jne againor          ;there is one so add +1 there
                     ;and do the +1 based on that
                     ;position all over again
mov word[ds:di],0d30h ;init next digit if there is
                      ;none present yet
jmp againor           ;and do another +1
finefine:

;hit something

;01h = nothing
;02h = 1 shot back
;03h = 2 shots back

cmp byte[ds:bp],2 ;hit ascii 02h ?
jb noadd          ;nope, you hit 01h or nothing
inc bx            ;get 1 shot back
cmp byte[ds:bp],2 ;hit the heart 03h?
jna noadd        ;unfortunately nope
inc bx            ;add 2 more shots
inc bx            ;which makes it 3 shots added

noadd:
mov word[ds:bp],dx;0  ;delete object/shot

jmp reset          ;deactivate shot please

no_hit:
mov word[ds:bp],09b3h ;draw shot

droppz:

mov word[ds:si],0e1eh ;draw player

;mov byte[ds:80*10+78+1],44h ;mark game over spot
inc byte[ds:80*10+78+1]
cmp byte[ds:80*10+78],dl     ;game over spot check
jne breaker                  ;enemy is there so bye bye

         mov ah,01h
         int 16h
         jz go_on               ;if no key pressed do nothing
                                ;and simply update screen

         mov ah,00h            ;key pressed so get the code
         int 16h               ;nouws

         cmp al,27             ;esc
         je breaker            ;bye bye

mov di,si ;copy for easier movement check

cut4:    cmp al,97             ;A
         jne cut6
         dec di        ;move
         dec di        ;move
cut6:    cmp al,100            ;D
         jne cut2
         inc di        ;move
         inc di        ;move
cut2:    cmp al,115            ;S
         jne cutx
         cmp bp,dx;0
         jne cutx ;shot already active
                  ;so not a shot again
         mov bp,si;set shot pos
         dec bx   ;ammo -1
         jz breaker
cutx:

cmp word[ds:di],dx;0 ;free space where to move?
jne go_on         ;no
mov word[ds:si],dx;0 ;del old one
mov si,di         ;yes, so set new pos
go_on:

jmp main

breaker: ret ;halt!